"use strict";

exports.__esModule = true;
exports.default = _default;

var _pluginSyntaxOptionalCatchBinding = _interopRequireDefault(require("@babel/plugin-syntax-optional-catch-binding"));

var _core = require("@babel/core");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default() {
  return {
    inherits: _pluginSyntaxOptionalCatchBinding.default,
    visitor: {
      CatchClause: function CatchClause(path) {
        if (path.node.param === null || !_core.types.isIdentifier(path.node.param)) {
          return;
        }

        var binding = path.scope.getOwnBinding(path.node.param.name);

        if (binding.constantViolations.length > 0) {
          return;
        }

        if (!binding.referenced) {
          var paramPath = path.get("param");
          paramPath.remove();
        }
      }
    }
  };
}